package xugu

import "errors"

type xuguTx struct {
	tconn *xuguConn
}

func (self *xuguTx) Commit() error {
	if self.tconn == nil {
		return errors.New("Invalid connection")
	}
	_, err := self.tconn.exec("commit;")

	_, err = self.tconn.exec("set auto_commit on;")
	if err != nil {
		return err
	}
	return nil
}

func (self *xuguTx) Rollback() error {

	if self.tconn == nil {
		return errors.New("Invalid connection")
	}
	_, err := self.tconn.exec("rollback;")
	if err != nil {
		return err
	}

	_, err = self.tconn.exec("set auto_commit on;")
	if err != nil {
		return err
	}
	return err
}
